#include <SPI.h>
#include <LoRa.h>
#include <Wire.h>
#include <DS3231.h>
#include <LiquidCrystal_I2C.h>
#include <OneWire.h>
#include <DallasTemperature.h>
#include <Servo.h>
LiquidCrystal_I2C lcd(0x27, 16, 2);
OneWire oneWire(3);
DallasTemperature DS18B20(&oneWire);
DS3231 rtc(SDA, SCL);
Servo servo;
int relay = 7;
float volt;
float voltr;
float volth;
int ntu;
int temp;
unsigned int ph_value = 0;
float Voltage = 0.0;
String kondisi = " ";

void setup() {
  Serial.begin(115200);
  lcd.init();
  lcd.backlight();
  DS18B20.begin();
  rtc.begin();
  servo.attach(6);
  servo.write(0);
  pinMode(relay, OUTPUT);
  //rtc.setTime(06, 11, 00);
  while (!Serial)
    ;
  Serial.println("LoRa Sender");
  if (!LoRa.begin(433E6)) {
    Serial.println("Starting LoRa failed!");
    while (1)
      ;
  }
}

void loop() {
  DS18B20.requestTemperatures();
  temp = DS18B20.getTempCByIndex(0);
  /////////////////////////////////////////////
  volt = 0;
  for (int i = 0; i < 800; i++) {
    volt += ((float)analogRead(0) / 1023) * 5;
  }
  voltr = volt / 800;
  volth = roundf(voltr * 10.0f) / 10.0f;
  if (volth < 2.5) {
    ntu = 3000;
  } else {
    ntu = -1120.4 * square(volth) + 5742.3 * volth - 4352.9;
  }
  if (ntu > 2000) {
    digitalWrite(relay, LOW);
    kondisi = "ON ";
  }
  if (ntu < 2000) {
    digitalWrite(relay, HIGH);
    kondisi = "OFF";
  }
  ////////////////////////////////////////////
  ph_value = 0;
  for (int cycle = 1; cycle <= 10; cycle++) {
    ph_value = ph_value + analogRead(1);
    delay(10);
  }
  float analog = (float)ph_value / 10.0;
  delay(50);
  Voltage = analog * (5.0 / 1023.0);
  float calibration_value = 21.34 + 1.3;
  float ph = -5.70 * Voltage + calibration_value;
  ///////////////////////////////////////////////////
  String waktu = rtc.getTimeStr();
  if (waktu == "07:00:00" || waktu == "07:00:01" || waktu == "16:00:00" || waktu == "16:00:01 " && ntu < 2000) {
    servo.write(90);
    delay(1000);
    servo.write(0);
  }
  //////////////////////////////////////////////
  lcd.setCursor(0, 0);
  lcd.print(ntu);
  lcd.print("NTU ");
  lcd.print(ph);
  lcd.print("pH ");
  lcd.setCursor(0, 1);
  lcd.print(temp);
  lcd.print("C ");
  lcd.print(waktu);
  lcd.print(" ");
  lcd.print(kondisi);
  /////////////////////////////////////////////
  String datakirim = String(ntu) + "#" + String(temp) + "#" + String(ph) + "#" + String(kondisi);
  LoRa.beginPacket();
  LoRa.print(datakirim);
  LoRa.endPacket();
  delay(1000);
}
