#include <SPI.h>
#include <LoRa.h>
#include <Wire.h>
#include  <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x3F, 16, 2);
String data;
String arrData[4];
int ntu;
int temp;
float ph;
String kondisi = " ";

void setup() {
  Serial.begin(9600);
  lcd.init();
  lcd.backlight();
  while (!Serial);
  Serial.println("LoRa Receiver");
  if (!LoRa.begin(433E6)) {
    Serial.println("Starting LoRa failed!");
    while (1);
  }
}

void loop() {
  int packetSize = LoRa.parsePacket();
  if (packetSize) {
    // received a packet
    data = "";
    // read packet
    while (LoRa.available()) {
      data += char (LoRa.read());
    }
    data.trim();

    if (data != "") {
      int index = 0;
      for (int i = 0; i <= data.length(); i++) {
        char delimiter = '#';
        if (data[i] != delimiter)
          arrData[index] += data[i];
        else
          index++;
      }

      if (index == 3) {
        Serial.println("ntu : " + arrData[0]);
        Serial.println("temp: " + arrData[1]);
        Serial.println("ph  : " + arrData[2]);
        Serial.println("kr  : " + arrData[3]);
        Serial.println("");
      }
    }
    ntu = arrData[0].toInt();
    temp = arrData[1].toInt();
    ph = arrData[2].toFloat();
    kondisi = arrData[3];
    arrData[0] = "";
    arrData[1] = "";
    arrData[2] = "";
    arrData[3] = "";
  }
  lcd.setCursor(0, 0);
  lcd.print(ntu);
  lcd.print("NTU ");
  lcd.print(ph);
  lcd.print("pH ");
  lcd.setCursor(0, 1);
  lcd.print(temp);
  lcd.print((char)223);
  lcd.print("C  ");
  lcd.print(kondisi);
  lcd.print(" ");
}
